"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
class LabelController extends aframe_typescript_boilerplate_1.AbstractComponentController {
    constructor(component, entity, data) {
        super(component, entity, data);
    }
    init() {
        //console.log(this.componentName + " init: " + JSON.stringify(this.data));
        const text = this.data['text'];
        const x = 0;
        const y = this.data['height'];
        const z = 0;
        this.labelElement = document.createElement('a-text');
        this.labelElement.setAttribute("value", text);
        this.labelElement.setAttribute("color", "#FFFFFF");
        this.labelElement.setAttribute("opacity", "0.5");
        this.labelElement.setAttribute("resizer", "");
        this.labelElement.setAttribute("billboard", "");
        this.labelElement.setAttribute("align", "center");
        this.labelElement.setAttribute("font", "kelsonsans");
        this.labelElement.setAttribute("scale", "0.5 0.5");
        this.labelElement.setAttribute("wrap-count", "30");
        this.labelElement.setAttribute("position", x.toFixed(2) + " " + y.toFixed(2) + " " + z.toFixed(2));
        this.entity.appendChild(this.labelElement);
    }
    update(data, oldData) {
        //console.log(this.componentName + " update: " + JSON.stringify(this.data));
    }
    remove() {
        //console.log(this.componentName + " remove");
    }
    pause() {
        //console.log(this.componentName + " pause");
    }
    play() {
        //console.log(this.componentName + " play");
    }
    tick(time, timeDelta) {
    }
}
LabelController.DEFINITION = new aframe_typescript_boilerplate_1.ComponentControllerDefinition("label", {
    text: { type: 'string', default: '?' },
    height: { type: 'number', default: 1.2 }
}, false, false, (component, entity, data) => new LabelController(component, entity, data));
exports.LabelController = LabelController;
//# sourceMappingURL=LabelController.js.map