import { AnimationAction, AnimationClip, AnimationMixer } from "three";
import { Entity } from "aframe";
import { StateSystemController } from "../../system/state/StateSystemController";
import { MovementState } from "../../model/MovementState";
import { ComponentController } from "aframe-typescript-boilerplate";
import { AbstractFeature } from "aframe-typescript-boilerplate";
export declare class AnimationFeature extends AbstractFeature {
    mixer: AnimationMixer | undefined;
    clips: Map<string, AnimationClip>;
    actions: Map<string, AnimationAction>;
    stateSystemController: StateSystemController;
    movementState: MovementState;
    constructor(controller: ComponentController, entity: Entity);
    init(): void;
    update(data: any, oldData: any): void;
    remove(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    private initAnimation;
    private onAnimationFinished;
    private beginAnimation;
    private endAnimation;
}
