"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AnimateEventDetail_1 = require("../../model/AnimateEventDetail");
const Events_1 = require("../../model/Events");
const AnimationLoopStyle_1 = require("./AnimationLoopStyle");
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
class ExpressionFeature extends aframe_typescript_boilerplate_1.AbstractFeature {
    constructor(controller, entity) {
        super("expression-controller", controller, entity);
        this.expressions = new Set();
    }
    init() {
        this.addEventListener(Events_1.Events.EVENT_STATE_BEGIN, (detail) => {
            if (detail.state === "moving") {
                this.dispatchEvent(Events_1.Events.EVENT_ANIMATE_BEGIN, new AnimateEventDetail_1.AnimationEventDetail("walking", AnimationLoopStyle_1.AnimationLoopStyle.LOOP_REPEAT, -1));
            }
        });
        this.addEventListener(Events_1.Events.EVENT_STATE_END, (detail) => {
            if (detail.state === "moving") {
                this.dispatchEvent(Events_1.Events.EVENT_ANIMATE_END, new AnimateEventDetail_1.AnimationEventDetail("walking", AnimationLoopStyle_1.AnimationLoopStyle.LOOP_REPEAT, 10));
            }
        });
    }
    update(data, oldData) {
    }
    remove() {
    }
    pause() {
    }
    play() {
    }
    tick(time, timeDelta) {
    }
}
exports.ExpressionFeature = ExpressionFeature;
//# sourceMappingURL=ExpressionFeature.js.map