"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const UserNameController_1 = require("./component/label/UserNameController");
const KeyboardAndMouseDevice_1 = require("./system/interface/device/KeyboardAndMouseDevice");
const AnimatorController_1 = require("./component/animation/AnimatorController");
const AvatarController_1 = require("./component/avatar/AvatarController");
const SpaceSystemController_1 = require("./system/space/SpaceSystemController");
const StateSystemController_1 = require("./system/state/StateSystemController");
const States_1 = require("./model/States");
const MovementState_1 = require("./model/MovementState");
const InterfaceSystemController_1 = require("./system/interface/InterfaceSystemController");
const InterfaceController_1 = require("./system/interface/InterfaceController");
const WalkTool_1 = require("./system/interface/tool/WalkTool");
const PrimaryControllerDevice_1 = require("./system/interface/device/PrimaryControllerDevice");
const AddObjectTool_1 = require("./system/interface/tool/AddObjectTool");
const CollidableController_1 = require("./component/collidable/CollidableController");
const QuaternionController_1 = require("./component/quaternion/QuaternionController");
const TeleportTool_1 = require("./system/interface/tool/TeleportTool");
const ToolSelectorTool_1 = require("./system/interface/tool/ToolSelectorTool");
const RemoveObjectTool_1 = require("./system/interface/tool/RemoveObjectTool");
const ModelController_1 = require("./system/merge/ModelController");
const MergeController_1 = require("./system/merge/MergeController");
const MergeSystemController_1 = require("./system/merge/MergeSystemController");
const LoaderSystemController_1 = require("./system/loader/LoaderSystemController");
const PictureController_1 = require("./component/texture/PictureController");
const BillboardController_1 = require("./component/texture/BillboardController");
const ScaleObjectTool_1 = require("./system/interface/tool/ScaleObjectTool");
const MoveObjectTool_1 = require("./system/interface/tool/MoveObjectTool");
const RotateObjectTool_1 = require("./system/interface/tool/RotateObjectTool");
const AvatarActionLoggerFeature_1 = require("./component/avatar/AvatarActionLoggerFeature");
require("./primitive/billboard");
require("./primitive/picture");
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
const ui_1 = require("@tlaukkan/aframe-material-collection-ts/built/src/ui");
const UiSystemController_1 = require("./system/ui/UiSystemController");
const ExampleView_1 = require("./system/ui/view/ExampleView");
ui_1.registerMaterialUiSystem();
aframe_typescript_boilerplate_1.registerSystemController(LoaderSystemController_1.LoaderSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(aframe_typescript_boilerplate_1.ExampleSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(InterfaceSystemController_1.InterfaceSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(StateSystemController_1.StateSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(SpaceSystemController_1.SpaceSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(MergeSystemController_1.MergeSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerSystemController(UiSystemController_1.UiSystemController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(ExampleView_1.ExampleView.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(InterfaceController_1.InterfaceController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(ToolSelectorTool_1.ToolSelectorTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(AddObjectTool_1.AddObjectTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(ScaleObjectTool_1.ScaleObjectTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(MoveObjectTool_1.MoveObjectTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(RotateObjectTool_1.RotateObjectTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(RemoveObjectTool_1.RemoveObjectTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(WalkTool_1.WalkTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(TeleportTool_1.TeleportTool.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(PrimaryControllerDevice_1.PrimaryControllerDevice.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(KeyboardAndMouseDevice_1.KeyboardAndMouseDevice.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(aframe_typescript_boilerplate_1.ExampleController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(CollidableController_1.CollidableController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(AnimatorController_1.AnimatorController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(AvatarController_1.AvatarController.DEFINITION.add(AvatarActionLoggerFeature_1.AvatarActionLoggerFeature.DEFINITION));
aframe_typescript_boilerplate_1.registerComponentController(UserNameController_1.UserNameController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(QuaternionController_1.QuaternionController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(MergeController_1.MergeController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(ModelController_1.ModelController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(PictureController_1.PictureController.DEFINITION);
aframe_typescript_boilerplate_1.registerComponentController(BillboardController_1.BillboardController.DEFINITION);
StateSystemController_1.registerStateFactory(States_1.States.STATE_MOVEMENT, () => { return new MovementState_1.MovementState(); });
// Fix facebook bug adding hash to url
if (window.location.hash && window.location.hash == '#_=_') {
    history.pushState("", document.title, window.location.pathname + window.location.search);
}
//# sourceMappingURL=index.js.map