"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
/**
 * Snaps vector to axis aligned grid.
 * @param vector the vector
 * @param step the grid step
 */
function snapVector3ToAxisAlignedGrid(vector, step) {
    const snappedPosition = new three_1.Vector3();
    snappedPosition.x = snapNumberToAxisAlignedGrid(vector.x, step);
    snappedPosition.y = snapNumberToAxisAlignedGrid(vector.y, step);
    snappedPosition.z = snapNumberToAxisAlignedGrid(vector.z, step);
    return snappedPosition;
}
exports.snapVector3ToAxisAlignedGrid = snapVector3ToAxisAlignedGrid;
/**
 * Snap number to grid.
 * @param number the number
 * @param step the grid step
 */
function snapNumberToAxisAlignedGrid(number, step) {
    return Math.floor(number / step) * step + step / 2;
}
exports.snapNumberToAxisAlignedGrid = snapNumberToAxisAlignedGrid;
//# sourceMappingURL=math.js.map