import { Component, Entity } from "aframe";
import { Device } from "../Device";
import { ComponentControllerDefinition } from "aframe-typescript-boilerplate";
import { CodeRealityComponentController } from "../../../component/CodeRealityComponentController";
export declare class KeyboardAndMouseDevice extends CodeRealityComponentController implements Device {
    static DEFINITION: ComponentControllerDefinition;
    movementForwardKey: string;
    movementBackwardKey: string;
    movementLeftKey: string;
    movementRightKey: string;
    jumpKey: string;
    rightKey: string;
    leftKey: string;
    upKey: string;
    downKey: string;
    pointerLock: boolean;
    lastWheelYTimeMillis: number;
    constructor(component: Component, entity: Entity, data: any);
    init(): void;
    update(data: any, oldData: any): void;
    remove(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    onKeyDown(key: string): void;
    onKeyUp(key: string): void;
}
