"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const Button_1 = require("../model/Button");
const PointerTool_1 = require("./PointerTool");
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
class GrabObjectTool extends PointerTool_1.PointerTool {
    constructor(component, entity, data) {
        super(component, entity, data);
        this.entityTemplateScale = 0.5;
        this.entityTemplate = "<a-box/>";
        this.raycaster = new three_1.Raycaster();
    }
    init() {
        //console.log(this.componentName + " init");
        super.init();
    }
    tick(time, timeDelta) {
        super.tick(time, timeDelta);
    }
    buttonDown(device, toolSlot, button) {
        if (!this.pressed.has(button)) {
            if (button == Button_1.Button.GRIP) {
                if (this.pointedObject) {
                }
                else {
                    if (!this.heldEntity) {
                        this.addEntity(device);
                    }
                }
            }
        }
        super.buttonDown(device, toolSlot, button);
    }
    buttonUp(device, toolSlot, button) {
        if (this.pressed.has(button)) {
            if (button == Button_1.Button.GRIP) {
                if (this.pointedObject) {
                }
                else {
                    if (this.heldEntity) {
                        this.releaseEntity();
                    }
                }
            }
        }
        super.buttonUp(device, toolSlot, button);
    }
    addEntity(device) {
        //console.log("add object");
        this.heldEntity = aframe_typescript_boilerplate_1.createElement(this.entityTemplate);
        this.heldEntity.setAttribute("scale", this.entityTemplateScale + " " + this.entityTemplateScale + " " + this.entityTemplateScale);
        this.heldEntity.setAttribute("position", "0 0 -" + this.entityTemplateScale * 2);
        device.entity.appendChild(this.heldEntity);
    }
    releaseEntity() {
        // Extract entity world position
        //const entityPosition = new Vector3();
        const entityPosition = this.heldEntity.object3D.getWorldPosition();
        const entityQuaternion = new three_1.Quaternion();
        this.heldEntity.object3D.getWorldQuaternion(entityQuaternion);
        //var entityRotation = (this.heldEntity!!.object3D as any).getWorldRotation();
        //(this.heldEntity!! as any).flushToDom();
        // Extract entity HTML description.
        this.heldEntity.flushToDOM();
        const entityHtml = this.heldEntity.outerHTML;
        // Remove entity from current parent.
        this.heldEntity.parentElement.removeChild(this.heldEntity);
        // Create new copy of entity
        this.heldEntity = aframe_typescript_boilerplate_1.createElement(entityHtml);
        // Set the world position and rotation.
        this.heldEntity.setAttribute("position", entityPosition.x + " " + entityPosition.y + " " + entityPosition.z);
        this.heldEntity.setAttribute("quaternion", entityQuaternion.x + " " + entityQuaternion.y + " " + entityQuaternion.z + " " + entityQuaternion.w);
        /*this.heldEntity!!.setAttribute("rotation",
            Math.radToDeg(entityRotation.x) + " " +
            Math.radToDeg(entityRotation.y) + " " +
            Math.radToDeg(entityRotation.z));*/
        this.scene.appendChild(this.heldEntity);
        // Add entity to scene.
        //this.heldEntity!!.setAttribute("position", entityPosition);
        //this.heldEntity!!.object3D.position.copy(entityPosition);
        //this.heldEntity!!.object3D.rotation.copy(entityRotation);
        //this.heldEntity!!.parentElement!!.removeChild(this.heldEntity!!);
        //this.scene.appendChild(this.heldEntity!!);
        //this.heldEntity!!.object3D.position.copy(entityPosition);
        //this.heldEntity!!.object3D.rotation.copy(entityRotation);
        //console.log(entityPosition);
        //this.heldEntity!!.object3D.position.copy(entityPosition);
        //this.heldEntity!!.flushToDOM();
        this.heldEntity = undefined;
    }
}
GrabObjectTool.DEFINITION = new aframe_typescript_boilerplate_1.ComponentControllerDefinition("grab-object-tool", {}, false, true, (component, entity, data) => new GrabObjectTool(component, entity, data));
exports.GrabObjectTool = GrabObjectTool;
//# sourceMappingURL=GrabObjectTool.js.map