import { Face3, LineBasicMaterial, Object3D, Raycaster, Vector3 } from "three";
import { Component, Entity } from "aframe";
import { Device } from "../Device";
import { Tool } from "../Tool";
import { Slot } from "../model/Slot";
import { Button } from "../model/Button";
import { Stick } from "../model/Stick";
import { ComponentControllerDefinition } from "aframe-typescript-boilerplate";
import { CodeRealityComponentController } from "../../../component/CodeRealityComponentController";
export declare class PointerTool extends CodeRealityComponentController implements Tool {
    static DEFINITION: ComponentControllerDefinition;
    readonly pointerMaterial: LineBasicMaterial;
    pressed: Set<Button>;
    time: number;
    raycaster: Raycaster;
    pointerLine: Object3D;
    pointerCursor: Object3D;
    pointerDevice: Device | undefined;
    pointerDevicePosition: Vector3;
    pointerDirection: Vector3;
    pointedPosition: Vector3 | undefined;
    pointedObject: Object3D | undefined;
    pointedFace: Face3 | undefined;
    constructor(component: Component, entity: Entity, data: any);
    init(): void;
    update(data: any, oldData: any): void;
    remove(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    buttonDown(device: Device, toolSlot: Slot, button: Button): void;
    buttonUp(device: Device, toolSlot: Slot, button: Button): void;
    stickTwist(device: Device, toolSlot: Slot, stick: Stick, x: number, y: number): void;
    constructPointerLine(): Object3D;
    constructPointerCursor(): Object3D;
    pointerOn(device: Device): void;
    pointerOff(device: Device): void;
    pointerTick(time: number, timeDelta: number): void;
    private addCursor;
    private removeCursor;
}
