"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const Button_1 = require("../model/Button");
const PointerTool_1 = require("./PointerTool");
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
class RemoveObjectTool extends PointerTool_1.PointerTool {
    constructor(component, entity, data) {
        super(component, entity, data);
        this.raycaster = new three_1.Raycaster();
    }
    init() {
        //console.log(this.componentName + " init");
        super.init();
    }
    tick(time, timeDelta) {
        super.tick(time, timeDelta);
    }
    buttonDown(device, toolSlot, button) {
        if (!this.pressed.has(button)) {
        }
        super.buttonDown(device, toolSlot, button);
    }
    buttonUp(device, toolSlot, button) {
        if (this.pressed.has(button)) {
            if (button == Button_1.Button.TRIGGER) {
                this.removeEntity(device);
            }
        }
        super.buttonUp(device, toolSlot, button);
    }
    removeEntity(device) {
        const pointedObject = this.pointedObject;
        const pointerPosition = this.pointedPosition;
        const spaceSystem = this.getSystemController("space");
        if (pointedObject && pointerPosition) {
            const pointedEntity = aframe_typescript_boilerplate_1.getEntity(pointedObject);
            if (pointedEntity) {
                spaceSystem.removeEntity(pointedEntity);
            }
        }
    }
}
RemoveObjectTool.DEFINITION = new aframe_typescript_boilerplate_1.ComponentControllerDefinition("remove-object-tool", {}, false, true, (component, entity, data) => new RemoveObjectTool(component, entity, data));
exports.RemoveObjectTool = RemoveObjectTool;
//# sourceMappingURL=RemoveObjectTool.js.map