"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const Slot_1 = require("../model/Slot");
const Button_1 = require("../model/Button");
const PointerTool_1 = require("./PointerTool");
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
class TeleportTool extends PointerTool_1.PointerTool {
    constructor(component, entity, data) {
        super(component, entity, data);
        //this.interface.setTool(ToolSlot.PRIMARY, this);
        this.raycaster = new three_1.Raycaster();
        this.interface.registerTool(this);
        this.interface.slotTool(Slot_1.Slot.PRIMARY, this);
    }
    init() {
        //console.log(this.componentName + " init");
        super.init();
    }
    tick(time, timeDelta) {
        super.tick(time, timeDelta);
    }
    buttonDown(device, toolSlot, button) {
        if (!this.pressed.has(button)) {
        }
        super.buttonDown(device, toolSlot, button);
    }
    buttonUp(device, toolSlot, button) {
        if (this.pressed.has(button)) {
            if (button == Button_1.Button.TRIGGER) {
                if (this.pointedPosition) {
                    const movementTool = this.interface.getToolAtSlot(Slot_1.Slot.WALK);
                    this.interface.interfaceEntity.object3D.position.x = this.pointedPosition.x;
                    this.interface.interfaceEntity.object3D.position.y = this.pointedPosition.y;
                    this.interface.interfaceEntity.object3D.position.z = this.pointedPosition.z;
                    movementTool.setCenterOfMassFromInterfaceEntity();
                }
            }
        }
        super.buttonUp(device, toolSlot, button);
    }
}
TeleportTool.DEFINITION = new aframe_typescript_boilerplate_1.ComponentControllerDefinition("teleport-tool", {}, false, true, (component, entity, data) => new TeleportTool(component, entity, data));
exports.TeleportTool = TeleportTool;
//# sourceMappingURL=TeleportTool.js.map