import { Component, Entity } from "aframe";
import { Tool } from "../Tool";
import { Device } from "../Device";
import { Button } from "../model/Button";
import { Slot } from "../model/Slot";
import { Stick } from "../model/Stick";
import { SlotListener } from "../SlotListener";
import { ComponentControllerDefinition } from "aframe-typescript-boilerplate";
import { CodeRealityComponentController } from "../../../component/CodeRealityComponentController";
export declare class ToolSelectorTool extends CodeRealityComponentController implements Tool, SlotListener {
    static DEFINITION: ComponentControllerDefinition;
    toolSymbolEntities: Map<String, Entity>;
    currentToolName: string | undefined;
    vrMode: boolean;
    constructor(component: Component, entity: Entity, data: any);
    init(): void;
    update(data: any, oldData: any): void;
    remove(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    buttonDown(device: Device, toolSlot: Slot, button: Button): void;
    buttonUp(device: Device, toolSlot: Slot, button: Button): void;
    stickTwist(device: Device, toolSlot: Slot, stick: Stick, x: number, y: number): void;
    onToolSlotted(slot: Slot, toolName: string): void;
}
