import { Entity, Scene, System } from "aframe";
import { MergeData } from "./MergeData";
import { AbstractSystemController, SystemControllerDefinition } from "aframe-typescript-boilerplate";
export declare class MergeSystemController extends AbstractSystemController {
    readonly merges: Map<Entity<import("aframe").ObjectMap<import("aframe").Component<any, System<any>>>>, MergeData>;
    startTime: number;
    loadingRegistered: boolean;
    static DEFINITION: SystemControllerDefinition;
    constructor(system: System, scene: Scene, data: any);
    init(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    addMerge(mergeEntity: Entity): void;
    addLoadingMergeChild(mergeEntity: Entity, mergeChildEntity: Entity): void;
    setMergeChildLoaded(mergeEntity: Entity, mergeChildEntity: Entity): void;
    merging: boolean;
    private merge;
    private collectObjectsToMerge;
    niceTimeoutCounter: number;
    private cloneObjectToMergeWithWait;
    private allocateMergeObjectIndex;
    private remove;
    private update;
    private cloneAndSwitchToRegionCoordinates;
    removeMergeChild(mergeEntity: Entity, mergeChildEntity: Entity): void;
    updateMergeChild(mergeEntity: Entity, mergeChildEntity: Entity): void;
    removeMerge(mergeEntity: Entity): void;
}
