import { Entity, Scene } from "aframe";
import { Quaternion, Vector3 } from "three";
import { Spring } from "./Spring";
import { StateSystemController } from "../state/StateSystemController";
import { MovementState } from "../../model/MovementState";
export declare class Actuator {
    id: string;
    index: number;
    region: string;
    description: string;
    scene: Scene;
    entity: Entity;
    springOne: Spring;
    springTwo: Spring;
    lastPosition: Vector3;
    facingDirection: Vector3;
    targetOrientation: Quaternion;
    currentOrientation: Quaternion;
    lastUpdateTime: number;
    averageUpdateInterval: number;
    moving: boolean;
    turning: boolean;
    firstSimulate: boolean;
    stateSystemController: StateSystemController;
    movementState: MovementState;
    cameraPosition: Vector3;
    constructor(scene: Scene, region: string, id: string, index: number, description: string);
    changeRegion(region: string, index: number): void;
    added(x: number, y: number, z: number, rx: number, ry: number, rz: number, rw: number): void;
    updated(x: number, y: number, z: number, rx: number, ry: number, rz: number, rw: number): void;
    removed(): void;
    described(description: string): void;
    acted(action: string, description: string): void;
    simulate(t: number): void;
    checkIfMoving(): void;
}
