import { Scene } from "aframe";
import { Actuator } from "./Actuator";
export declare class DynamicSpace {
    scene: Scene;
    avatarId: string;
    avatarIndex: number;
    actuatorsMap: Map<string, Map<number, Actuator>>;
    actuatorRemoves: Map<string, Actuator>;
    constructor(scene: Scene, avatarId: string);
    connected(region: string): void;
    disconnected(region: string): void;
    added(region: string, index: number, id: string, x: number, y: number, z: number, rx: number, ry: number, rz: number, rw: number, description: string): void;
    updated(region: string, index: number, x: number, y: number, z: number, rx: number, ry: number, rz: number, rw: number): void;
    removed(region: string, index: number, id: string): void;
    described(region: string, index: number, description: string): void;
    acted(region: string, index: number, action: string, description: string): void;
    simulate(t: number): void;
}
