import { Quaternion, Vector3 } from "three";
import { Entity, Scene, System } from "aframe";
import { StaticSpace } from "./StaticSpace";
import { AbstractSystemController, SystemControllerDefinition } from "aframe-typescript-boilerplate";
export declare class SpaceSystemController extends AbstractSystemController {
    static DEFINITION: SystemControllerDefinition;
    private clusterUrl;
    private idToken;
    private context;
    private space;
    private avatarId;
    private playerElement;
    private cameraElement;
    private playerObject;
    private cameraObject;
    private client;
    private dynamicSpace;
    staticSpace: StaticSpace | undefined;
    private lastRefresh;
    private yAxisPositive;
    private xzPlane;
    private cameraDirection;
    private xzDirection;
    private directionMatrix;
    private directionQuaternion;
    private observationRange;
    constructor(system: System, scene: Scene, data: any);
    init(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    setupClient(): void;
    getObservationRange(): number;
    sendAvatarDescriptionUpdate(): void;
    private getAvatarDescription;
    addEntity(template: string, position: Vector3, scale: Vector3): void;
    updateEntity(entity: Entity, position: Vector3, orientation: Quaternion, scale: Vector3): void;
    removeEntity(entity: Entity): void;
}
