import { Entity, Scene } from "aframe";
import { Vector3 } from "three";
import { Element as XmlElement } from "xml-js";
export declare class StaticSpace {
    scene: Scene;
    regionElements: Map<string, Element>;
    loadingRegions: Set<string>;
    ignoreNextSetSids: Array<string>;
    constructor(scene: Scene);
    connected(region: string, regionOrigo: Vector3): void;
    loaded(region: string): void;
    disconnected(region: string): void;
    private addToLoadingRegions;
    private removeFromLoadingRegions;
    setRootEntity(region: string, sid: string, entityXml: string): void;
    recursiveUpdate(existingElement: Element, newElement: XmlElement): void;
    setChildEntity(region: string, parentSid: string, sid: string, entityXml: string): void;
    removeEntity(region: string, sid: string): void;
    getElement(sid: string): Entity | undefined;
}
