import { Entity, Scene, System } from "aframe";
import { AbstractSystemController, SystemControllerDefinition } from "aframe-typescript-boilerplate";
export declare function registerStateFactory<T>(state: string, factory: () => T): void;
export declare class StateSystemController extends AbstractSystemController {
    static DEFINITION: SystemControllerDefinition;
    private states;
    constructor(system: System, scene: Scene, data: any);
    init(): void;
    pause(): void;
    play(): void;
    tick(time: number, timeDelta: number): void;
    getState<T>(entity: Entity, state: string): T;
    removeStates(entity: Entity): void;
    removeState(entity: Entity, state: string): void;
}
