"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const aframe_1 = __importDefault(require("aframe"));
const aframe_typescript_boilerplate_1 = require("aframe-typescript-boilerplate");
const ExampleView_html_1 = __importDefault(require("./ExampleView.html"));
const util_1 = require("../../../util");
class ExampleView extends aframe_typescript_boilerplate_1.AbstractComponentController {
    constructor(component, entity, data) {
        super(component, entity, data);
        this.template = ExampleView_html_1.default;
    }
    init() {
        const elements = util_1.createElements(this.template);
        for (const element of elements) {
            this.entity.append(element);
        }
    }
    update(data, oldData) {
    }
    remove() {
        //console.log(this.componentName + " remove");
    }
    pause() {
        //console.log(this.componentName + " pause");
    }
    play() {
        //console.log(this.componentName + " play");
    }
    tick(time, timeDelta) {
    }
}
ExampleView.DEFINITION = new aframe_typescript_boilerplate_1.ComponentControllerDefinition("example-view", {}, false, false, (component, entity, data) => new ExampleView(component, entity, data));
exports.ExampleView = ExampleView;
aframe_1.default.registerPrimitive('a-example-view', aframe_1.default.utils.extendDeep({}, aframe_1.default.primitives.getMeshMixin(), {
    defaultComponents: {
        "example-view": {}
    },
    mappings: {}
}));
//# sourceMappingURL=ExampleView.js.map