/**
 * @author mrdoob, tlaukkan (copied from threejs BufferGeometryUtil.js typescript and added extendability, dropped morph attributes support)
 */
import { BufferAttribute, BufferGeometry, Material } from "three";
export declare class BufferGeometryMerge {
    groupOffset: number;
    indexOffset: number;
    readonly indexMerge: number[];
    readonly attributeMerges: Map<string, BufferAttributeMerge>;
    material: Material | Material[];
    geometry: BufferGeometry;
    constructor(material: Material | Material[]);
    freeObjectIndexes: Set<number>;
}
declare class BufferAttributeMerge {
    offset: number;
    attribute: BufferAttribute;
    objectIndexAttributeRanges: Map<number, Array<[number, number]>>;
    constructor(attribute: BufferAttribute, offset: number);
}
export declare function mergeBufferGeometries(merge: BufferGeometryMerge, geometries: Array<BufferGeometry>, useGroups: boolean): Promise<BufferGeometry>;
export declare function clearBufferGeometries(merge: BufferGeometryMerge, geometries: Array<BufferGeometry>): BufferGeometry;
export declare function updateBufferGeometries(merge: BufferGeometryMerge, geometries: Array<BufferGeometry>): BufferGeometry;
export {};
