"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function raycast(objects, raycaster) {
    const intersects = new Array();
    raycastRecursive(objects, raycaster, intersects);
    intersects.sort(ascSort);
    return intersects;
}
exports.raycast = raycast;
function raycastRecursive(objects, caster, intersects) {
    for (const object of objects) {
        object.raycast(caster, intersects);
        if (object.children && object.children.length > 0) {
            raycastRecursive(object.children, caster, intersects);
        }
    }
}
function ascSort(a, b) {
    return a.distance - b.distance;
}
//# sourceMappingURL=raycast.js.map