"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = __importDefault(require("config"));
const server_1 = require("./server");
start().then().catch(e => console.log('code reality - startup error: ', e));
function start() {
    return __awaiter(this, void 0, void 0, function* () {
        console.log("code reality - starting up version='" + config_1.default.get('Software.version') + "'");
        const port = config_1.default.get('Server.port');
        const host = config_1.default.get('Server.host');
        const server = yield server_1.newServer(host, port);
        process.on('exit', () => __awaiter(this, void 0, void 0, function* () {
            console.log("code reality - exiting version='" + config_1.default.get('Software.version') + "'");
            yield server.close();
        }));
    });
}
//# sourceMappingURL=app.js.map